var
  ProcKind: Integer;
  q: TcsViewQuery;
  qX: TcsExecSQLQuery;
  SummaFullCheck,
  SummaMoney,  SummaCheck: currency;
  PayList: string;
  KindCheck: Integer;
  IdDoc: Integer;
  cntAlreadyPrinted: Integer;
begin
  KindCheck := 0;
  IdDoc := frVariables['IdDoc'];
  // IdDoc := 350776;
  //frVariables['ReportName'] := '   ';
  q := TcsViewQuery.Create(nil);
  q.DatabaseName := MainDatabaseName;
  try
    if (frVariables['ReportName'] = '   ') then
      begin
        // 
        q.SQL.Add('select count(id) as cnt from main m ');
        q.SQL.Add(' where m.id = :idmain and coalesce(m.iskkm,0) = 1');
        q.ParamByName('IdMain').AsInteger := IdDoc;
        q.Open;
        cntAlreadyPrinted := q.FieldByName('cnt').AsInteger;
        q.Close;
        if cntAlreadyPrinted > 0 then
          begin
            if ShowQuest('     ' + #13 + '  ?') then
              begin
                if ShowQuest('  ' + #13 + '     ' + #13 + '  ?') then
                  begin
                    SQLExecute('update main set iskkm = 0 where id = ' + IntToStr(IdDoc));
                  end;
              end;
          end;
        q.SQL.Clear;
        q.SQL.Add('select m.summa as summa, t1.code as t1code, t2.code as t2code ');
        q.SQL.Add('from main m ');
        q.SQL.Add('left outer join type_oper t1 on t1.id = m.idtype1 ');
        q.SQL.Add('left outer join type_oper t2 on t2.id = m.idtype2 ');
        q.SQL.Add(' where m.id = :idmain and coalesce(m.iskkm,0) = 0');
        q.ParamByName('IdMain').AsInteger := IdDoc;
        q.Open;
        if (copy(q.FieldByName('t1code').AsString, 1, 2) = '50')
          and (copy(q.FieldByName('t2code').AsString, 1, 2) = '60') then
          KindCheck := 1
        else if (copy(q.FieldByName('t2code').AsString, 1, 2) = '50')
          and (copy(q.FieldByName('t1code').AsString, 1, 2) = '60') then
          KindCheck := 2;
        SummaFullCheck := q.FieldByName('Summa').AsCurrency;
        SummaCheck := SummaFullCheck;
        q.Close;
        ProcKind := 1;
      end
    else
    if (frVariables['ReportName'] = '   /  ') then
      begin
        // 
        q.SQL.Add('select count(id) as cnt from main m ');
        q.SQL.Add(' where m.id = :idmain and coalesce(m.iskkm,0) = 1');
        q.ParamByName('IdMain').AsInteger := IdDoc;
        q.Open;
        cntAlreadyPrinted := q.FieldByName('cnt').AsInteger;
        q.Close;
        if cntAlreadyPrinted > 0 then
          begin
            if ShowQuest('     ' + #13 + '  ?') then
              begin
                if ShowQuest('  ' + #13 + '     ' + #13 + '  ?') then
                  begin
                    SQLExecute('update main set iskkm = 0 where id = ' + IntToStr(IdDoc));
                  end;
              end;
          end;
        q.SQL.Clear;
        q.SQL.Add('select m.summa as summa, t1.code as t1code, t2.code as t2code ');
        q.SQL.Add('from main m ');
        q.SQL.Add('left outer join type_oper t1 on t1.id = m.idtype1 ');
        q.SQL.Add('left outer join type_oper t2 on t2.id = m.idtype2 ');
        q.SQL.Add(' where m.id = :idmain and coalesce(m.iskkm,0) = 0');
        q.ParamByName('IdMain').AsInteger := IdDoc;
        q.Open;
        if (copy(q.FieldByName('t2code').AsString, 1, 2) = '41') then
          KindCheck := 1
        else if (copy(q.FieldByName('t1code').AsString, 1, 2) = '41') then
          KindCheck := 2;
        SummaFullCheck := q.FieldByName('Summa').AsCurrency;
        SummaCheck := SummaFullCheck;
        q.Close;
        ProcKind := 3;
      end
    else
      begin
        q.SQL.Clear;
        q.SQL.Add('select sum(m.summa) as summa');
        q.SQL.Add('from platbydoc p ');
        q.SQL.Add('left outer join main m on m.id = p.idplat ');
        q.SQL.Add('left outer join type_oper t on t.id = m.idtype1 ');
        q.SQL.Add(' where p.iddoc = :idmain and coalesce(m.iskkm,0) = 0 and t.code like ''50%'' ');
        q.ParamByName('IdMain').AsInteger := IdDoc;
        q.Open;
        SummaFullCheck := q.FieldByName('Summa').AsCurrency;
        SummaCheck := SummaFullCheck;
        q.Close;
        KindCheck := 1;
        ProcKind := 2;
      end;
    if KindCheck > 0 then
      begin
        if KKMShowPayForm(SummaFullCheck, SummaCheck, PayList) then
          begin
            qX := TcsExecSQLQuery.Create(nil);
            qX.DatabaseName := MainDatabaseName;
            if ProcKind = 1 then
              begin
                qX.SQL.Add('execute procedure printcheckbydocsum(:idmain,:iduser,:computername,:kkm_printrates,');
                qX.SQL.Add(':headerstring,:footerstring,:kindcheck)');
                qX.ParamByName('kindcheck').AsInteger := KindCheck;
                qX.ParamByName('kkm_printrates').AsInteger := 0;
              end
            else if ProcKind = 2 then
              begin
                qX.SQL.Add('execute procedure PRINTCHECKFORPLAT(:idmain,:iduser,:computername,');
                qX.SQL.Add(':headerstring,:footerstring)');
              end
            else if ProcKind = 3 then
              begin
              {    idmain integer,
    iduser integer,
    computername char(30) character set win1251,
    idpaylist integer,
    summamoney numeric(15,3),
    kkm_printonlysumma integer,
    kkm_printrates integer,
    headerstring char(256) character set win1251,
    footerstring char(256) character set win1251,
    kindcheck integer = 1)
}
                qX.SQL.Add('execute procedure PRINTCHECKBYDOC(:idmain,:iduser,:computername,:idpaylist,:SummaMoney,');
                qX.SQL.Add(':kkm_printonlysumma,:kkm_printrates,');
                qX.SQL.Add(':headerstring,:footerstring,:kindcheck)');
                qX.ParamByName('SummaMoney').AsCurrency := SummaFullCheck;
                qX.ParamByName('kindcheck').AsInteger := KindCheck;
                qX.ParamByName('IdPayList').AsInteger := 0;
                qX.ParamByName('kkm_printrates').AsInteger := 0;
                qX.ParamByName('kkm_printonlysumma').AsInteger := 0;

              end;

            qX.ParamByName('IdMain').AsInteger := IdDoc;
            qX.ParamByName('IdUser').AsInteger := frVariables['UserId'];
            qX.ParamByName('ComputerName').AsString := frVariables['Computername'];
            qX.ParamByName('headerstring').AsString := '';
            qX.ParamByName('footerstring').AsString := '';
            qX.ExecSQL;
            qx.Free;

          end;

      end
    else
      ShowError('     (  )');
  finally

    q.Free;
  end;
end.